// Decompiled by Jad v1.5.8c. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 

package tilt.game;


// Referenced classes of package tilt.game:
//            Game, a, d, h

public final class GameState
{

    public GameState(Game game, Maze maze, float x, float y)
    {
        wallHitSpeedThreshold = TiltConstants.wallHitSpeedThreshold;
        friction = TiltConstants.friction;
        wallElasticity = TiltConstants.wallElacticity;
        k = TiltConstants.f;
        theGame = game;
        theSoundPlayer = new SoundPlayer();
        currentX = x;
        currentY = y;
        theMaze = maze;
    }

    public final float getCurrentX()
    {
        return currentX;
    }

    public final float getCurrentY()
    {
        return currentY;
    }

    public final void setTilt(float x, float y)
    {
        tiltX = x;
        tiltY = y;
    }

    public final void setCurrentLocation(float x, float y)
    {
        currentX = x;
        currentY = y;
    }

    public final void move(int milliseconds)
    {
        currentXInt = (int)currentX;
        currentYInt = (int)currentY;
        boolean hitWall = false;
        boolean hitWallUpDown = false;
        boolean hitWallLeftRight = false;
        for(int counter = 0; counter < milliseconds; counter++)
        {
            // Calculate new location based on old location and speed
            float newX = currentX + speedX / 1000F;
            float newY = currentY + speedY / 1000F;
            if(isWall(newX, newY))
            {
                if(isWall(newX, currentY))
                {
                    // Don't change the X
                    newX = currentX;
                    // If we hit hard enough, signal a hit
                    if(Math.abs(speedX) > wallHitSpeedThreshold)
                    {
                        hitWall = true;
                        hitWallLeftRight = true;
                    }
                    // Bounce back, according to wall elacticity
                    speedX = -speedX * wallElasticity;
                }
                if(isWall(currentX, newY))
                {
                    // Don't change the Y
                    newY = currentY;
                    // If we hit hard enough, signal a hit
                    if(Math.abs(speedY) > wallHitSpeedThreshold)
                    {
                        hitWall = true;
                        hitWallUpDown = true;
                    }
                    // Bounce back, according to wall elacticity
                    speedY = -speedY * wallElasticity;
                }
            }
            // Update our position
            currentX = newX;
            currentY = newY;
            // Reduce speed by coefficient of friction
            speedX *= friction;
            speedY *= friction;
            // Alter speed based on accelleration of gravity/tilt
            speedX += tiltX / 1000F;
            speedY += tiltY / 1000F;
        }
        // Did we hit the exit?
        if((int)currentX == theMaze.getExitX() && (int)currentY == theMaze.getExitY())
            theGame.finishedLevel();
        // Did we hit a wall with enough force to signal a hit?
        if(hitWall)
        {
            theSoundPlayer.playHitSound();
            if(hitWallUpDown)
                theGame.writeFeedback(30);
            if(hitWallLeftRight)
                theGame.writeFeedback(40);
        }
        // Did we move a complete square?
        if(currentXInt != (int)currentX || currentYInt != (int)currentY)
        {
            theSoundPlayer.playMoveSound();
            theGame.writeFeedback(20);
        }
    }

    public final void setMaze(Maze maze)
    {
        theMaze = maze;
    }

    private boolean isWall(float f1, float f2)
    {
        byte byte0;
        return (byte0 = (byte)((byte0 = (byte)((byte0 = (byte)((byte0 = theMaze.getMapCoordinate((int)(f1 - k), (int)(f2 - k))) + theMaze.getMapCoordinate((int)((f1 + k) - 0.01F), (int)(f2 - k)))) + theMaze.getMapCoordinate((int)((f1 + k) - 0.01F), (int)((f2 + k) - 0.01F)))) + theMaze.getMapCoordinate((int)(f1 - k), (int)((f2 + k) - 0.01F)))) != 0;
    }

    private float currentX;
    private float currentY;
    private float speedX;
    private float speedY;
    private float tiltX;
    private float tiltY;
    private float wallHitSpeedThreshold;
    private float friction;
    private float wallElasticity;
    private Maze theMaze;
    private float k;
    private SoundPlayer theSoundPlayer;
    private Game theGame;
    private int currentXInt;
    private int currentYInt;
}
