// Decompiled by Jad v1.5.8c. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 

package tilt.game;

import java.io.*;

public final class Maze
{

    public Maze()
    {
        grid = new byte[200][200];
        ballStartX = 1;
        ballStartY = 1;
        exitX = 8;
        exitY = 8;
    }

    /**
     * Do some kind of verification or post-processing of the maze.  Mainly, this checks
     * that there are walls along all edges and checks some kind of connection/adjacent
     * stuff.
     */
    public final void verifyMaze()
    {
        maxY = 0;
        maxX = 0;
        minY = 300;
        minX = 300;
        // Determine maximum size of the maze
        for(int y = 0; y < 200; y++)
        {
            for(int x = 0; x < 200; x++)
                if(grid[y][x] != 0)
                {
                    maxY = Math.max(maxY, y);
                    maxX = Math.max(maxX, x);
                    minY = Math.min(minY, y);
                    minX = Math.min(minX, x);
                }

        }
        // Ensure there are walls along all edges, so you don't fall off the map
        for(int i = 0; i < 200; i++)
        {
            grid[i][0] = 1;
            grid[i][199] = 1;
            grid[0][i] = 1;
            grid[199][i] = 1;
        }

        // Run checkConnecting along random points on the walls.  Why?  Don't know.
        for(int i = 0; i < 10; i++)
        {
            checkConnecting(0, (int)(Math.random() * 199D));
            checkConnecting(199, (int)(Math.random() * 199D));
            checkConnecting((int)(Math.random() * 199D), 0);
            checkConnecting((int)(Math.random() * 199D), 199);
        }
        // Run checkConnecting along random points within the grid 100,000 times.  Why?  Don't know. 
        for(int i = 0; i < 100000; i++)
            checkConnectingAtRandomPosition();

        exitX = 198;
        exitY = 198;
    }

    /**
     * Check if the position is an inner wall.  Outer walls don't count.
     * @param x x location
     * @param y y location
     * @return
     */
    private boolean isInnerWall(int x, int y)
    {
        if(x < 0 || x > 199 || y < 0 || y > 199)
            return false;
        if(x >= minY && y >= minX && x <= maxY && y <= maxX)
            return false;
        return grid[x][y] != 0;
    }

    /**
     * Is the grid position at (x,y) empty?
     * @param x x location
     * @param y y location
     * @return
     */
    private boolean isEmpty(int x, int y)
    {
        if(x < 0 || x > 199 || y < 0 || y > 199)
            return false;
        return grid[x][y] != 1;
    }

    /**
     * Find an empty square adjancent to (x,y).  
     * @param x xposition
     * @param y yposition
     * @return -1 if it is totally walled off
     *          0 if there is an empty square to the left
     *          1 is there is an empty square to the right
     *          2 if there is an empty square above
     *          3 if there is an empty square below
     */
    private int getAdjacentEmptyDirection(int x, int y)
    {
        boolean aflag[] = new boolean[] {true, true, true, true};
        // Check if there is are empty spaces above, below, or to the side
        aflag[0] = isEmpty(x, y - 1);
        aflag[1] = isEmpty(x, y + 1);
        aflag[2] = isEmpty(x - 1, y);
        aflag[3] = isEmpty(x + 1, y);
        // If all four are walls, return -1
        if(!aflag[0] && !aflag[1] && !aflag[2] && !aflag[3])
            return -1;
        // Pick a random starting position
        int direction = (int)(Math.random() * 4D);
        do
        {
            // If there is an empty space in "direction" return it. 
            if(aflag[direction])
                break;
            // Loop back around to 0 if past 3
            if(++direction > 3)
                direction = 0;
        } while(true);
        return direction;
    }

    /**
     * Runs checkConnecting at a random location on the grid.  Why?  I don't know.
     */
    private void checkConnectingAtRandomPosition()
    {
        int x = (int)(Math.random() * 199D);
        int y = (int)(Math.random() * 199D);
        checkConnecting(x, y);
    }

    /**
     * Not entirely sure what this does, but it checks for empty adjacent squares...?
     * @param x
     * @param y
     */
    private void checkConnecting(int x, int y)
    {
        int direction;
        if(isInnerWall(x, y) && (direction = getAdjacentEmptyDirection(x, y)) != -1)
        {
            int i1 = (int)(Math.random() * 20D + 10D);
            boolean flag = false;
            for(; i1 > 0; i1--)
            {
                grid[x][y] = 1;
                if(direction == 0) //left
                {
                    y--;
                    flag = (flag = (flag = (flag = (flag |= !isEmpty(x - 1, y - 1)) | (!isEmpty(x, y - 1))) | (!isEmpty(x + 1, y - 1))) | (!isEmpty(x + 1, y))) | (!isEmpty(x - 1, y));
                }
                if(direction == 1) // right
                {
                    y++;
                    flag = (flag = (flag = (flag = (flag |= !isEmpty(x - 1, y + 1)) | (!isEmpty(x, y + 1))) | (!isEmpty(x + 1, y + 1))) | (!isEmpty(x + 1, y))) | (!isEmpty(x - 1, y));
                }
                if(direction == 2) // above
                {
                    x--;
                    flag = (flag = (flag = (flag = (flag |= !isEmpty(x - 1, y - 1)) | (!isEmpty(x - 1, y))) | (!isEmpty(x - 1, y + 1))) | (!isEmpty(x, y + 1))) | (!isEmpty(x, y - 1));
                }
                if(direction == 3) // below
                {
                    x++;
                    flag = (flag = (flag = (flag = (flag |= !isEmpty(x + 1, y - 1)) | (!isEmpty(x + 1, y))) | (!isEmpty(x + 1, y + 1))) | (!isEmpty(x, y + 1))) | (!isEmpty(x, y - 1));
                }
                if(flag)
                    return;
            }

        }
    }

    public final int getBallStartX()
    {
        return ballStartX;
    }

    public final int getBallStartY()
    {
        return ballStartY;
    }

    public final int getExitX()
    {
        return exitX;
    }

    public final int getExitY()
    {
        return exitY;
    }

    public final byte getMapCoordinate(int j, int k)
    {
        return grid[j][k];
    }

    public final void setMapCoordinate(int j, int k, byte byte0)
    {
        grid[j][k] = byte0;
    }

    public final void loadMap(InputStream inputstream)
        throws IOException
    {
        DataInputStream datainputstream;
        int height = (datainputstream = new DataInputStream(inputstream)).readInt();
        int width = datainputstream.readInt();
        ballStartX = datainputstream.readInt();
        ballStartY = datainputstream.readInt();
        exitX = datainputstream.readInt();
        exitY = datainputstream.readInt();
        for(int l = 0; l < height; l++)
        {
            for(int i1 = 0; i1 < width; i1++)
                grid[l][i1] = (byte)datainputstream.read();

        }

    }

    private byte grid[][];
    private int ballStartX;
    private int ballStartY;
    private int exitX;
    private int exitY;
    private int minY;
    private int minX;
    private int maxY;
    private int maxX;
}
